/***
*
*   Lblrun.prg
*   ⥬ ६ ᯮ  Clipper 5.0 LABEL FORM
*   Copyright (c) 1990 Nantucket Corp.   ࠢ ࠭.
*
*   ஢:  /m/n/w
*/

#include "lbldef.ch"                 // ᠭ ᨢ ଠ ⨪⪨
#include "error.ch"


// File-wide static declarations
STATIC aLabelData                   // ᨢ ଠ ⨪⪨
STATIC aBandToPrint := {}
STATIC cBlank
STATIC lOneMoreBand := .T.
STATIC nCurrentCol  := 1            //  


/***
*  __LabelForm( ... ) --> NIL
*
*   ⨪⪨  (.lbl)-䠩 ଠ  ᥩ
*   㪠뢠  ⢨    ᮮ⢥⢨  ᫮ﬨ
*
*/

FUNCTION __LabelForm( cLBLName, lPrinter, cAltFile, lNoConsole, bFor, ;
                       bWhile, nNext, nRecord, lRest, lSample )
LOCAL lPrintOn := .F.
LOCAL lConsoleOn := .T.
LOCAL cExtraFile, lExtraState
LOCAL xBreakVal, lBroke := .F.
LOCAL err
Local OldMargin


   // ஢ઠ ࠬ஢
   IF cLBLName == NIL
      err := ErrorNew()
      err:severity := 2
      err:genCode := EG_ARG
      err:subSystem := "FRMLBL"
      Eval(ErrorBlock(), err)

   ELSE
      IF AT( ".", cLBLName ) == 0
         cLBLName := TRIM( cLBLName ) + ".LBL"
      ENDIF

   ENDIF

   IF lPrinter == NIL
      lPrinter := .F.
   ENDIF

   IF lNoConsole == NIL
      lNoConsole := .F.
   ENDIF

   IF lSample == NIL
      lSample := .F.
   ENDIF

   // ⠭ 뢮 ன⢠
   IF lPrinter          //  ਭ
      lPrintOn	 := SET( _SET_PRINTER, lPrinter )
   ENDIF

   IF lNoConsole        //  ࠭
      lConsoleOn := SET( _SET_CONSOLE, .F. )
   ENDIF

   IF (!Empty(cAltFile))      //  
      cExtraFile  := SET( _SET_EXTRAFILE, cAltFile )
      lExtraState := SET( _SET_EXTRA, .T. )
   ENDIF

   OldMargin := SET( _SET_MARGIN, 0)

   BEGIN SEQUENCE

      aLabelData := __LblLoad( cLBLName )  //  ᨢ  .lbl-䠩

      //   , ᫨ SET MARGIN 뫮 ।
      aLabelData[ LB_LMARGIN ] += OldMargin

      // ਢ ᨢ aBandToPrint     
      ASIZE( aBandToPrint, LEN( aLabelData[ LB_FIELDS ] ) )
      AFILL( aBandToPrint, SPACE( aLabelData[ LB_LMARGIN ] ) )

      //   ஡  ⮩ 
      cBlank := SPACE( aLabelData[ LB_WIDTH ] + aLabelData[ LB_SPACES ] )

      IF USED()     // ।饭  (ZAL 06/19/91 07:45pm)
        RECNO()
      ENDIF


      // ࠡ⪠ ਬ ⨪⪨
      IF lSample
         SampleLabels()
      ENDIF

      // ନ஢ ⨪⪨  ᯥ஢ ᥩ
      DBEval( { || ExecuteLabel() }, bFor, bWhile, nNext, nRecord, lRest )

      //  ᫥ 㯯 ப, ᫨  
      IF lOneMoreBand
      //  㯯 ப
      AEVAL( aBandToPrint, ;
		{ | BandLine | ; // PrintIt( SPACE(aLabelData[LB_LMARGIN])+ BandLine ) ;
		   PrintIt( BandLine ) ;
		} ;
          )
      ENDIF


   RECOVER USING xBreakVal

      lBroke := .T.

   END

   // ⪠  砭
   aLabelData   := {}                // ⮩ ᨢ
   aBandToPrint := {}
   nCurrentCol  := 1
   cBlank       := ""
   lOneMoreBand :=.T.

   // ⠭ ⠭  ࢮ砫쭮 ﭨ:
   SET( _SET_PRINTER, lPrintOn )  // ਭ
   SET( _SET_CONSOLE, lConsoleOn )  // ᮫

   IF (!Empty(cAltFile))            // ⥫ 䠩
      SET( _SET_EXTRAFILE, cExtraFile )
      SET( _SET_EXTRA, lExtraState )
   ENDIF

   IF lBroke
      BREAK xBreakVal               // த 뢠
   ENDIF

   SET( _SET_MARGIN, OldMargin)

RETURN NIL


/***
*  ExecuteLabel() --> NIL
*  ࠡ⪠ ⥪饩   ᮮ⢥⢨  ᨢ ᠭ ଠ
*/
STATIC FUNCTION ExecuteLabel
LOCAL nField, nMoreLines, aBuffer := {}, cBuffer
LOCAL v

   //  aBuffer  ⥪饩 
   FOR nField := 1 TO LEN( aLabelData[ LB_FIELDS ] )

		if ( aLabelData[ LB_FIELDS, nField ] <> NIL )

			v := Eval( aLabelData[ LB_FIELDS, nField, LF_EXP ] )

			cBuffer := PadR( v, aLabelData[ LB_WIDTH ] )
			cBuffer += Space( aLabelData[ LB_SPACES ] )


			if ( aLabelData[ LB_FIELDS, nField, LF_BLANK ] )
				if ( !Empty( cBuffer ) )
					AAdd( aBuffer, cBuffer )
				end
			else
				AAdd( aBuffer, cBuffer )
			endif

		else

			AAdd( aBuffer, NIL )

		end

   NEXT

   ASIZE( aBuffer, LEN( aLabelData[ LB_FIELDS ] ) )

   //  aBuffer  aBandToPrint
   FOR nField := 1 TO LEN( aLabelData[ LB_FIELDS ] )
      IF aBuffer[ nField ] == NIL
         aBandToPrint[ nField ] += cBlank
      ELSE
         aBandToPrint[ nField ] += aBuffer[ nField ]
      ENDIF
   NEXT

   IF nCurrentCol == aLabelData[ LB_ACROSS ]


    //  墮⮢ ஡
	  FOR nField := 1 TO LEN( aBandToPrint )
		 aBandToPrint[ nField ] := Trim( aBandToPrint[ nField ] )
	  NEXT


      lOneMoreBand := .F.
      nCurrentCol  := 1

      // 
      AEVAL( aBandToPrint, ;
         { | BandLine | ;     //----PU---PrintIt( SPACE(aLabelData[LB_LMARGIN])+ BandLine ) ;
            PrintIt( BandLine ) ;
         } ;
      )
      nMoreLines := aLabelData[ LB_HEIGHT ] - LEN( aBandToPrint )
      IF nMoreLines > 0
         FOR nField := 1 TO nMoreLines
            PrintIt()
         NEXT
      ENDIF
      IF aLabelData[ LB_LINES ] > 0

         //  ப  ⨪⪠
         FOR nField := 1 TO aLabelData[ LB_LINES ]
            PrintIt()
         NEXT

      ENDIF

      // ⪠ ᨢ
      AFILL( aBandToPrint, SPACE( aLabelData[ LB_LMARGIN ] ) )
   ELSE
      lOneMoreBand := .T.
      nCurrentCol++
   ENDIF

RETURN NIL


/***
*  SampleLabels() --> NIL
*   ਬ ⨪⪨
*/
STATIC FUNCTION SampleLabels
LOCAL nGetKey, lMoreSamples := .T., nField
LOCAL aBand := {}

   //  ப ਬ ⨪⪨
   ASIZE( aBand, aLabelData[ LB_HEIGHT ] )
   AFILL( aBand, SPACE( aLabelData[ LB_LMARGIN ] ) +;
              REPLICATE( REPLICATE( "*", ;
              aLabelData[ LB_WIDTH ] ) + ;
              SPACE( aLabelData[ LB_SPACES ] ), ;
              aLabelData[ LB_ACROSS ] ) )

   //  ਬ ⨪⪨
   DO WHILE lMoreSamples

      //  ਬ஢
       AEVAL( aBand, ;
          { | BandLine | ;
            PrintIt( BandLine ) ;
          } ;
      )
      IF aLabelData[ LB_LINES ] > 0
         //  ப  ⨪⪠
         FOR nField := 1 TO aLabelData[ LB_LINES ]
            PrintIt()
         NEXT
      ENDIF

      //   த 
      @ ROW(), 0 SAY "  ਬ? (/)"
      nGetKey := INKEY(0)
      @ ROW(), COL() SAY CHR(nGetKey)
      IF ROW() == MAXROW()
         SCROLL( 0, 0, MAXROW(), MAXCOL(), 1 )
         @ MAXROW(), 0 SAY ""
      ELSE
         @ ROW()+1, 0 SAY ""
      ENDIF
      IF UPPER(CHR(nGetKey)) # ""
         lMoreSamples := .F.
      ENDIF
   ENDDO
RETURN NIL


/***
*  PrintIt( <cString> ) --> NIL
*   ப  / (CR/LF) ᫥ 
*/
STATIC FUNCTION PrintIt( cString )

   IF cString == NIL
      cString := ""
   ENDIF
   QQOUT( cString )
   QOUT()

RETURN NIL
